
TODO:
\begin{itemize}
  \item Motivations of the project
  \item Useful references
\end{itemize}


\paragraph{Applications}
Similarity in recommendation systems, Cleaning messy data,



\paragraph{Used notations}
A graph $G$ is defined as a tuple $G=(V,E)$, where $V$ is the set of all vertices, and $E$ is the set of all edges $E\subset V\times V$ (an edge is represented by a tuple of the starting node and the target node: $e=(u,v)$ with $u\in V$, $v \in V$). By convention, there are $n$ vertices ($|V|=n$) and $m$ edges ($|E|=m$).

% focus on bipartite graphs?shall we add simple directed and undirected graphs?

\paragraph{Random graph generation}
Starting from an observed graph $G_0$, one generates a certain number of other graphs $G_i$ with specific (wanted) properties (e.g., same number of nodes, same number of links, or same degree sequence, etc.). The idea is to use these newly generated graphs $G_i$ to assess the statistical significance of measures made in the observed one $G_0$.

Several models exist for random graph generation: $G(n,p)$ a.k.a Erdos-Reyni, ... FSDM. The relevance of the model (how realistic the model is) depends upon the application. FSDM have been shown to be relevant to the following contexts: TBD.

\paragraph{Cooccurrence}
The cooccurence is informally defined as the number of common numbers between two given node in a graph. Formally, let $u$ and $v$ be two nodes ($u \in V$, $v \in V$)

\begin{equation}
  coocc(u,v) = \sum_{w\in V}
  \begin{cases}
   1 & \text{if } (u,w) \in E \text{ and } (v,w) \in E \\
   0 & \text{otherwise}
  \end{cases}
\end{equation}




\paragraph{Cooccurrence assessment problem definition}

Given the co-occurrence $coocc(x,y)$ of any two nodes in a graph, assess the statistical significance of this value by comparison with its expected value in a suitable random graph model, e.g., the FDSM (see schematic overview in Fig. \ref{scm.coocc.assess}).


\begin{figure}
  \input{schema/coocc_assess}
  \caption{A schematic representation of the cooccurrence assessment problem.}
  \label{scm.coocc.assess}
\end{figure}

\begin{figure}
  \begin{itemize}
    \item[INPUTS] An observed graph $G_0$ (also called original graph); Two nodes $u$, $v$; A significance threshold $p$
    \item[OUTPUT] Whether or not $coocc_0(u,v)$ is statistically significant
    \item[Step 0] let $p-value(u,v) = 0$ be the sample p-value for the cooccurence of nodes $u$ and $v$
    \item[Step 1] Count the cooccurence $coocc_0(u,v)$ of two given nodes $u$ and $v$ in the original graph $G_0$.
    \item[Step 2] FOR $k\in [1,K]$ DO:
    \begin{itemize}
      \item[] $G_k \leftarrow \mathrm{RandomGraph}_{FSDM}(G_0)$ (generate a random graph from the FSDM)
      \item[] Count the cooccurence $coocc_k(u,v)$ of two given nodes $u$ and $v$ in the current graph $G_k$.
      \item[] IF $coocc_k(u,v) \geq coocc_0(u,v)$, THEN:
      \begin{itemize}
        \item[] $p-value(u,v) \leftarrow p-value(u,v) + 1$ increment the sample p-value of the cooccurrence of nodes $u$ and $v$.
      \end{itemize}
      \item[] END IF
    \end{itemize}
    \item[] END FOR
    \item[Step 3] IF $p-value(u,v)/K < p$ THEN: the cooccurence $coocc_0(u,v)$ of nodes $u$ and $v$, in the original graph $G_0$ IS statistically significant
  \end{itemize}
  \caption{Pseudo code for assessing the statistical significance of the cooccurence $coocc_0(u,v)$ of two nodes $u$, $v$ in the original graph $G_0$}
  \label{}
\end{figure}



\paragraph{Statistical measures related to cooccurrence}
The average of the cooccurence over a certain number of sample (will estimate the mean over all graphs)
\begin{equation}
  coocc_{FSDM}(u,v) = mean( \{coocc_i(u,v)\}_{i=1\dots|samples|} )
\end{equation}

The leverage, estimates how far the cooccurence is from the average.
\begin{equation}
  leverage(u,v) = coocc(u,v) - coocc_{FSDM}(u,v)
\end{equation}

\begin{equation}
  p-value(u,v) = \sum_{i=1}^{|samples|}
  \begin{cases}
   1 & \text{if } coocc_i(u,w) > coocc(u,v) \\
   0 & \text{otherwise}
  \end{cases}
\end{equation}

\begin{equation}
  z-score(u,v) = \frac{leverage(u,v)}{std( \{coocc_i(u,v)\}_{i=1\dots|samples|} )}
\end{equation}

\paragraph{Efficiency?}
How computationnaly costly is the whole approach? One has to generate several random graphs plus, for each, compute the cooccurence (see schematic overview in Fig. \ref{scm.coocc.assess}).


What is the cost of generating a single random graph (of course this depends upon the algorithm used), [give several examples of algorithms and their correposnding  cost / complexity]; Curveball is linear in number of steps and linear in size of the graph.


What is the cost of computing cooccurrence. Worst case would be $\bigO(n^2)$. But some algorithms may decrease it (but still have to do it for every generated graph).


Other than cost (memory, time, data movements) the size of the graph may be problematic (big data, real world graphs like protein-protein interactions or wikipedia pages may be too large to fit in the RAM).


So what does it mean to be efficient? Find a consensus between time and memory consumption.

\paragraph{Contribution}
A parallel algorithm and implementation of the cooccurence computation for large graphs (large in the sense that we need to distinguish when the graph data structure may or may not fit in the RAM). Experiments to measure the gain of each approaches.




\paragraph{Datastructure choice and memory}
There are mainly three type of datastructure to represent a graph: the adjacency matrix, the adjacency list (adjacency map), and the edge list.

\begin{itemize}
  \item[Adjacency matrix] (formal definition here), $A$ where $a_{i,j} = 1$ when $(i,j) \in E$ (i.e., nodes $i$ and $j$ are connected), $a_{i,j} = 0$ otherwise.
  \item[Adjacency list] (formal definition here), $L$ where $l_i = N_i$, each row is the set of neighbors from node $i$.
  \item[Global edge list] (formal definition here)
\end{itemize}





How much memory do they need? Adjacency matrix takes $n^2$ bits to store. Adjancency list takes $\sum_{i=1}^{n} deg(i).size$ bits where $size$ is the amount of bits needed to store a node index (usually 32 bits, unsigned Integer) and $deg(i)$ is the degree of node $i$. Global edge list will require $2m.size$ bits ($m$ edges consisting of starting node and target node indices). When the degree is not known, one may approximate the ammount of memory with a statistical indicator of the degree distribution (e.g., the expected degree). For instance, in the FSDM model, one can direclty compute the memory needed for the adjacency list. For the $G(n,p)$ model, the expected degree being $p$, one can approximate the memory required to $n.p.size$ bits with an error of TBD (other skewed degree distribution, like power law, will require more detailed statistical knowledge of the distribution to find an appropriate approximation).


When is $n^2 < \sum_{i=1}^{n} deg(i).size$ important (i.e., when an adjacency matrix representation needs less memory than an adjacency list one) depends upon the degree sequence (or degree distributions). Whether $n^2 < \sum_{i=1}^{n} deg(i).size$ matters, depends upon the hardware chosen and the algorithm used (see for instance the approach from [Wehn, Zweig] where hardware chips specifically designed using out-memory uses adjacency matrix whereas other in-memory approaches like [TBD] prefer to use adjacency list).


\paragraph{File format and space consumption}
The Netflix dataset (20k) is saved as a global edge list. Uncompressed it requires 39173564 bytes (38Mb)\footnote{As for Linux, Ubuntu 17.04, ext4 filesystem}. The corresponding adjacency map encoded in json format requires 21613431 bytes (21Mb, corresponding to $55.1\%$ of the previous 38Mb). The same adjacency map represented in a csv format requires 21529243 bytes (21Mb corresponding to $54.9\%$ of the initial 38Mb)

\begin{table}
  \begin{tabular}{c|ccc}
    file format & newlines & bytes & maximum line length \\
    \hline
    edge list (csv) & 3284330 & 39173564 & 12\\
    adjacency map (json) & 16839 & 21613431 & 55079\\
    adjacency map (csv) & 16837 & 21529243 & 55074\\
    \hline
  \end{tabular}
  \caption{Obtained from GNU'S wc command with options \texttt{--lines} \texttt{--bytes} \texttt{-L}}
  \label{table.file.size}
\end{table}

\begin{figure}
  \begin{verbatim}
15 10001
15 10002
15 10003
15 10004
15 10005
15 10006
15 10007
15 10008
15 10009
15 10010
  \end{verbatim}
  \caption{10 first lines of the edge list format (csv)}
  \label{fig.edgelist.csv}
\end{figure}

\begin{figure}
  \begin{verbatim}
{
"15":[10001,10002,10003,10004,10005,10006,10007,10008,10009,10010...
"16":[10013,10014,10015,10016,10017,10018,10019,10020,10021,10022...
"17":[10825,10826,10827,10828,10829,10830,10831,10832,10833,10834...
"18":[12572,12573,12574,12575,12576,12577,10013,12578,12579,12580...
"19":[11097,10133,10297,10365,11743,11945,12283],
"21":[13867,10734],
"22":[13928],
"23":[10043,13085,13667,10193,11345,11385,11656,11743,12099,12362...
"24":[10024,12700,10042,12805,10072,10969,10083,13145,13248,13570...
...
}
  \end{verbatim}
  \caption{10 first lines (cut after column 66) and last line of the adjacency list format (json)}
  \label{fig.adjmap.json}
\end{figure}

\begin{figure}
  \begin{verbatim}
15:10001,10002,10003,10004,10005,10006,10007,10008,10009,10010...
16:10013,10014,10015,10016,10017,10018,10019,10020,10021,10022...
17:10825,10826,10827,10828,10829,10830,10831,10832,10833,10834...
18:12572,12573,12574,12575,12576,12577,10013,12578,12579,12580...
19:11097,10133,10297,10365,11743,11945,12283
21:13867,10734
22:13928
23:10043,13085,13667,10193,11345,11385,11656,11743,12099,12362...
24:10024,12700,10042,12805,10072,10969,10083,13145,13248,13570...
25:12643,12688,12722,12773,12905,13010,13018,13101,13219,13278...
  \end{verbatim}
  \caption{10 first lines (cut after column 66) of the adjacency map format (csv)}
  \label{fig.adjmap.csv}
\end{figure}
